﻿using Infragistics.Graphics;
using Infragistics.Portable.Components.Data;
using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGeographicMapDuplicatePointsTest
{
    public partial class Form1 : Form
    {
        List<GeoPoint> points = new List<GeoPoint>();
        public Form1()
        {
            InitializeComponent();

            points.Add(new GeoPoint() { X = -0.1278, Y = 51.5074 });
            points.Add(new GeoPoint() { X = 121.4737, Y = 31.2304 });

            GeoPoint duplicate1 = new GeoPoint() { X = 151.2093, Y = -33.8688 };
            GeoPoint duplicate2 = new GeoPoint() { X = -74.0060, Y = 40.7128 };

            points.Add(duplicate1);
            points.Add(duplicate1);
            points.Add(duplicate2);
            points.Add(duplicate2);

            BingMapsMapImagery imagery = new BingMapsMapImagery()
            {
                ApiKey = "Aj2inbXEmvSbAbbVUKH1-DWlUeWIGjFTY3K2K8d1lqE5mEwI3_1oFX2U2tqONiHF"
            };

            ultraGeographicMap1.SetImagery(imagery);

            foreach(GeoPoint point in points)
            {
                var x = points.Where(p => p.X == point.X && p.Y == point.Y);

                if(x.Count() > 1)
                {
                    point.IsDuplicate = true;
                }
            }

            CustomRenderTemplate template = new CustomRenderTemplate();
            template.Render = new DataTemplateRenderHandler(TemplateRender);
            template.Measure = new DataTemplateMeasureHandler(TemplateMeasure);

            GeographicSymbolSeries series = new GeographicSymbolSeries()
            {                
                DataSource = points,
                LatitudeMemberPath = "Y",
                LongitudeMemberPath = "X",
                MarkerType = MarkerType.Circle,         
                MarkerTemplate = template
                //IsCustomScatterStyleAllowed = true,
                //IsCustomScatterMarkerStyleAllowed = true
            };            

            //series.AssigningScatterMarkerStyle += Series_AssigningScatterMarkerStyle;            
            ultraGeographicMap1.Series.Add(series);
        }

        //private void Series_AssigningScatterMarkerStyle(object sender, AssigningScatterMarkerStyleEventArgs args)
        //{
        //    GeoPoint point = args.GetItems(args.StartIndex, args.EndIndex)[0] as GeoPoint;

        //    var duplicateCheck = points.Where(p => p.X == point.X && p.Y == point.Y);
        //    if(duplicateCheck.Count() > 1)
        //    {
        //        args.Fill = Brushes.Red;
        //        args.Stroke = Brushes.Red;
        //    }
        //}


        public void TemplateMeasure(DataTemplateMeasureInfo info)
        {
            info.Height = 12;
            info.Width = 12;
        }

        public void TemplateRender(DataTemplateRenderInfo info)
        {
            System.Drawing.Graphics graphics = info.Context as System.Drawing.Graphics;

            GeoPoint geoPoint = info.Data.GetType().GetProperty("Item").GetValue(info.Data) as GeoPoint;

            if (graphics != null)
            {
                if (geoPoint.IsDuplicate)
                {
                    graphics.FillRectangle(Brushes.Red, new RectangleF((int)info.XPosition - 6, (int)info.YPosition - 6, 12, 12));
                }
                else
                {
                    graphics.FillRectangle(Brushes.Green, new RectangleF((int)info.XPosition - 6, (int)info.YPosition - 6, 12, 12));
                }                
            }
        }
    }




    public class GeoPoint
    {
        public double X { get; set; }
        public double Y { get; set; }
        public bool IsDuplicate { get; set; }
    }
}
